import 'payment_data.dart';

enum PaymentResultStatus { succeeded, failed, pending }

class PaymentInfoModel {
  int? id;
  int? type;
  String? firebaseQR;
  String? paymentMethod;
  PaymentMethodInfo? paymentMethodInfo;
  String? countryCode;
  String? currency;
  double? amount;
  int? commissionId;
  PaymentResultStatus? status;
  String? error;
  int? timestamp;
  String? transactionFriendlyId;
  PaymentDataModel? paymentData;

  int? deliveryLocationId;
  int? fromShop;
  String? gateway;

  PaymentInfoModel(
      {this.id,
      this.type,
      this.firebaseQR,
      this.paymentMethod,
      this.paymentMethodInfo,
      this.countryCode,
      this.currency,
      this.amount,
      this.commissionId,
      this.status,
      this.error,
      this.timestamp,
      this.transactionFriendlyId,
      this.deliveryLocationId,
      this.fromShop,
      this.gateway});

  PaymentInfoModel.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    type = json['type'];
    firebaseQR = json['firebaseQR'];
    paymentMethod = json['paymentMethod'];
    paymentMethodInfo = null;
    countryCode = json['countryCode'];
    currency = json['currency'];
    amount = json['amount'];
    commissionId = json['commissionId'];
    status = PaymentResultStatus.values.byName(json['status']);
    transactionFriendlyId = json['transactionFriendlyId'];
    error = json['error'];
    timestamp = json['timestamp'];
    deliveryLocationId = json['deliveryLocationId'];
    fromShop = json['fromShop'];
    gateway = json['gateway'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['type'] = this.type;
    data['firebaseQR'] = this.firebaseQR;
    data['paymentMethod'] = this.paymentMethod;
    if (this.paymentMethodInfo != null) {
      data['paymentMethodInfo'] = this.paymentMethodInfo!.toJson();
    }
    data['countryCode'] = this.countryCode;
    data['currency'] = this.currency;
    data['amount'] = this.amount;
    data['commissionId'] = this.commissionId;
    data['status'] = this.status!.toString();
    data['error'] = this.error;
    data['timestamp'] = this.timestamp;
    data['transactionFriendlyId'] = this.transactionFriendlyId;
    data['deliveryLocationId'] = this.deliveryLocationId;
    data['fromShop'] = this.fromShop;
    data['gateway'] = this.gateway;
    return data;
  }
}

class PaymentMethodInfo {
  dynamic data;
  PaymentMethodInfo({this.data});

  PaymentMethodInfo.fromJson(Map<String, dynamic> json) {
    data = json;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    return data;
  }
}
