class PlaylistItemModel {
  int? id;
  String? label;
  String? value;
  int? duration;
  int? itemOrder;
  int? playlistId;
  int? audio;
  ContentType? contentType;

  PlaylistItemModel(
      {this.id,
      this.label,
      this.value,
      this.duration,
      this.itemOrder,
      this.playlistId,
      this.audio,
      this.contentType});

  PlaylistItemModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["label"] is String) this.label = json["label"];
    if (json["value"] is String) this.value = json["value"];
    if (json["duration"] is int) this.duration = json["duration"];
    if (json["itemOrder"] is int) this.itemOrder = json["itemOrder"];
    if (json["playlistId"] is int) this.playlistId = json["playlistId"];
    if (json["audio"] is int) this.audio = json["audio"];
    if (json["contentType"] is Map)
      this.contentType = json["contentType"] == null
          ? null
          : ContentType.fromJson(json["contentType"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["label"] = this.label;
    data["value"] = this.value;
    data["duration"] = this.duration;
    data["itemOrder"] = this.itemOrder;
    data["playlistId"] = this.playlistId;
    data["audio"] = this.audio;
    if (this.contentType != null)
      data["contentType"] = this.contentType?.toJson();
    return data;
  }
}

class ContentType {
  int? id;
  String? label;

  ContentType({this.id, this.label});

  ContentType.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["label"] is String) this.label = json["label"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["label"] = this.label;
    return data;
  }
}
