import 'package:flutter/material.dart';
import 'package:_private_core/_private_core.dart';

class SellerMissionModel {
  ProInfoModel? proInfo;
  MissionInfo? missionInfo;
  int? isTaken;
  // as ExpandableNotifierState
  GlobalKey expandableKey = GlobalKey();

  SellerMissionModel({this.isTaken, this.proInfo, this.missionInfo});

  SellerMissionModel.fromJson(Map<String, dynamic> json) {
    if (json["isTaken"] is int) this.isTaken = json["isTaken"];
    if (json["proInfo"] is Map)
      this.proInfo = json["proInfo"] == null
          ? null
          : ProInfoModel.fromJson(json["proInfo"]);
    if (json["missionInfo"] is Map)
      this.missionInfo = json["missionInfo"] == null
          ? null
          : MissionInfo.fromJson(json["missionInfo"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.proInfo != null) data["proInfo"] = this.proInfo?.toJson();
    if (this.missionInfo != null)
      data["missionInfo"] = this.missionInfo?.toJson();
    data["isTaken"] = this.isTaken;
    return data;
  }
}

class MissionInfo {
  String? id;
  int? missionType;
  String? missionTypeName;
  int? sellerId;
  int? getAt;
  int? succeedAt;
  String? qrCode;
  int? elseGetIt;
  int? completed;
  String? instruction;
  String? colorCode;
  String? pictureUrl;
  int? timeForMission;

  Color? get color {
    if (colorCode != null) return hexColor(colorCode!);
  }

  MissionInfo(
      {this.id,
      this.missionType,
      this.missionTypeName,
      this.sellerId,
      this.getAt,
      this.succeedAt,
      this.qrCode,
      this.elseGetIt,
      this.completed,
      this.instruction,
      this.pictureUrl,
      this.colorCode,
      this.timeForMission});

  MissionInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is String) this.id = json["id"];
    if (json["missionType"] is int) this.missionType = json["missionType"];
    if (json["missionTypeName"] is String)
      this.missionTypeName = json["missionTypeName"];
    if (json["sellerId"] is int) this.sellerId = json["sellerId"];
    if (json["getAt"] is int) this.getAt = json["getAt"];
    if (json["succeedAt"] is int) this.succeedAt = json["succeedAt"];
    if (json["qrCode"] is String) this.qrCode = json["qrCode"];
    if (json["elseGetIt"] is int) this.elseGetIt = json["elseGetIt"];
    if (json["completed"] is int) this.completed = json["completed"];
    if (json["instruction"] is String) this.instruction = json["instruction"];
    if (json["pictureUrl"] is String) this.pictureUrl = json["pictureUrl"];
    // this.timeForMission = json['timeForMission'] ?? 0;
    this.timeForMission = 60 * 60 * 72;
    this.colorCode = json["colorCode"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["missionType"] = this.missionType;
    data["missionTypeName"] = this.missionTypeName;
    data["sellerId"] = this.sellerId;
    data["getAt"] = this.getAt;
    data["succeedAt"] = this.succeedAt;
    data["qrCode"] = this.qrCode;
    data["elseGetIt"] = this.elseGetIt;
    data["completed"] = this.completed;
    data["instruction"] = this.instruction;
    data["pictureUrl"] = this.pictureUrl;
    data["colorCode"] = this.colorCode;
    data["timeForMission"] = this.timeForMission;
    return data;
  }
}

class ProInfoModel {
  int? id;
  String? uniqueId;
  String? displayName;
  String? street1;
  String? city;
  int? mainSubcat;
  String? mainSubcatName;
  int? distance;
  String? loginQrCode;
  String? email;
  String? phone;

  ProInfoModel(
      {this.id,
      this.uniqueId,
      this.displayName,
      this.street1,
      this.city,
      this.mainSubcat,
      this.mainSubcatName,
      this.distance,
      this.email,
      this.phone,
      this.loginQrCode});

  ProInfoModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) this.id = json["id"];
    if (json["uniqueId"] is String) this.uniqueId = json["uniqueId"];
    if (json["displayName"] is String) this.displayName = json["displayName"];
    if (json["street1"] is String) this.street1 = json["street1"];
    if (json["city"] is String) this.city = json["city"];
    if (json["mainSubcat"] is int) this.mainSubcat = json["mainSubcat"];
    if (json["mainSubcatName"] is String)
      this.mainSubcatName = json["mainSubcatName"];
    if (json["distance"] is int) this.distance = json["distance"];
    if (json["phone"] is int) this.phone = json["phone"];
    if (json["email"] is int) this.email = json["email"];
    if (json["loginQrCode"] is int) this.loginQrCode = json["loginQrCode"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["id"] = this.id;
    data["uniqueId"] = this.uniqueId;
    data["displayName"] = this.displayName;
    data["street1"] = this.street1;
    data["city"] = this.city;
    data["mainSubcat"] = this.mainSubcat;
    data["mainSubcatName"] = this.mainSubcatName;
    data["distance"] = this.distance;
    data["phone"] = this.phone;
    data["email"] = this.email;
    data["loginQrCode"] = this.loginQrCode;
    return data;
  }
}
