class SubscriptionState {
  int? id;
  dynamic agencyId;
  dynamic subscriptionActiveUntil;
  dynamic autoRenewActivated;
  dynamic subscriptionExpirationEmailReminder;
  dynamic subscriptionAutoRenewEmailReminder;
  dynamic numberOfAdsRemaining;
  dynamic adsRemainingEmailReminder;
  dynamic numberOfAdsInPackageOrigin;
  dynamic countryAllowed;
  dynamic isWorldPass;
  dynamic orderId;

  SubscriptionState(
      {this.id,
      this.agencyId,
      this.subscriptionActiveUntil,
      this.autoRenewActivated,
      this.subscriptionExpirationEmailReminder,
      this.subscriptionAutoRenewEmailReminder,
      this.numberOfAdsRemaining,
      this.adsRemainingEmailReminder,
      this.numberOfAdsInPackageOrigin,
      this.countryAllowed,
      this.isWorldPass,
      this.orderId});

  SubscriptionState.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    agencyId = json["agencyId"];
    subscriptionActiveUntil = json["subscriptionActiveUntil"];
    autoRenewActivated = json["autoRenewActivated"];
    subscriptionExpirationEmailReminder =
        json["subscriptionExpirationEmailReminder"];
    subscriptionAutoRenewEmailReminder =
        json["subscriptionAutoRenewEmailReminder"];
    numberOfAdsRemaining = json["numberOfAdsRemaining"];
    adsRemainingEmailReminder = json["adsRemainingEmailReminder"];
    numberOfAdsInPackageOrigin = json["numberOfAdsInPackageOrigin"];
    countryAllowed = json["countryAllowed"];
    isWorldPass = json["isWorldPass"];
    orderId = json["orderId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["id"] = id;
    _data["agencyId"] = agencyId;
    _data["subscriptionActiveUntil"] = subscriptionActiveUntil;
    _data["autoRenewActivated"] = autoRenewActivated;
    _data["subscriptionExpirationEmailReminder"] =
        subscriptionExpirationEmailReminder;
    _data["subscriptionAutoRenewEmailReminder"] =
        subscriptionAutoRenewEmailReminder;
    _data["numberOfAdsRemaining"] = numberOfAdsRemaining;
    _data["adsRemainingEmailReminder"] = adsRemainingEmailReminder;
    _data["numberOfAdsInPackageOrigin"] = numberOfAdsInPackageOrigin;
    _data["countryAllowed"] = countryAllowed;
    _data["isWorldPass"] = isWorldPass;
    _data["orderId"] = orderId;
    return _data;
  }

  SubscriptionState copyWith({
    int? id,
    dynamic agencyId,
    dynamic subscriptionActiveUntil,
    dynamic autoRenewActivated,
    dynamic subscriptionExpirationEmailReminder,
    dynamic subscriptionAutoRenewEmailReminder,
    dynamic numberOfAdsRemaining,
    dynamic adsRemainingEmailReminder,
    dynamic numberOfAdsInPackageOrigin,
    dynamic countryAllowed,
    dynamic isWorldPass,
    dynamic orderId,
  }) =>
      SubscriptionState(
        id: id ?? this.id,
        agencyId: agencyId ?? this.agencyId,
        subscriptionActiveUntil:
            subscriptionActiveUntil ?? this.subscriptionActiveUntil,
        autoRenewActivated: autoRenewActivated ?? this.autoRenewActivated,
        subscriptionExpirationEmailReminder:
            subscriptionExpirationEmailReminder ??
                this.subscriptionExpirationEmailReminder,
        subscriptionAutoRenewEmailReminder:
            subscriptionAutoRenewEmailReminder ??
                this.subscriptionAutoRenewEmailReminder,
        numberOfAdsRemaining: numberOfAdsRemaining ?? this.numberOfAdsRemaining,
        adsRemainingEmailReminder:
            adsRemainingEmailReminder ?? this.adsRemainingEmailReminder,
        numberOfAdsInPackageOrigin:
            numberOfAdsInPackageOrigin ?? this.numberOfAdsInPackageOrigin,
        countryAllowed: countryAllowed ?? this.countryAllowed,
        isWorldPass: isWorldPass ?? this.isWorldPass,
        orderId: orderId ?? this.orderId,
      );
}
