class TheMoviePerson {
  String? profilePath;
  bool? adult;
  int? id;
  List<TheMoviePersonKnownFor>? knownFor;
  String? name;
  num? popularity;

  TheMoviePerson(
      {this.profilePath,
      this.adult,
      this.id,
      this.knownFor,
      this.name,
      this.popularity});

  TheMoviePerson.fromJson(Map<String, dynamic> json) {
    profilePath = json["profile_path"];
    adult = json["adult"];
    id = json["id"];
    knownFor = json["known_for"] == null
        ? null
        : (json["known_for"] as List)
            .map((e) => TheMoviePersonKnownFor.fromJson(e))
            .toList();
    name = json["name"];
    popularity = json["popularity"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["profile_path"] = profilePath;
    _data["adult"] = adult;
    _data["id"] = id;
    if (knownFor != null) {
      _data["known_for"] = knownFor?.map((e) => e.toJson()).toList();
    }
    _data["name"] = name;
    _data["popularity"] = popularity;
    return _data;
  }

  TheMoviePerson copyWith({
    String? profilePath,
    bool? adult,
    int? id,
    List<TheMoviePersonKnownFor>? knownFor,
    String? name,
    num? popularity,
  }) =>
      TheMoviePerson(
        profilePath: profilePath ?? this.profilePath,
        adult: adult ?? this.adult,
        id: id ?? this.id,
        knownFor: knownFor ?? this.knownFor,
        name: name ?? this.name,
        popularity: popularity ?? this.popularity,
      );
}

class TheMoviePersonKnownFor {
  String? posterPath;
  bool? adult;
  String? overview;
  String? releaseDate;
  String? originalTitle;
  List<int>? genreIds;
  int? id;
  String? mediaType;
  String? originalLanguage;
  String? title;
  String? backdropPath;
  num? popularity;
  int? voteCount;
  bool? video;
  num? voteAverage;

  TheMoviePersonKnownFor(
      {this.posterPath,
      this.adult,
      this.overview,
      this.releaseDate,
      this.originalTitle,
      this.genreIds,
      this.id,
      this.mediaType,
      this.originalLanguage,
      this.title,
      this.backdropPath,
      this.popularity,
      this.voteCount,
      this.video,
      this.voteAverage});

  TheMoviePersonKnownFor.fromJson(Map<String, dynamic> json) {
    posterPath = json["poster_path"];
    adult = json["adult"];
    overview = json["overview"];
    releaseDate = json["release_date"];
    originalTitle = json["original_title"];
    genreIds =
        json["genre_ids"] == null ? null : List<int>.from(json["genre_ids"]);
    id = json["id"];
    mediaType = json["media_type"];
    originalLanguage = json["original_language"];
    title = json["title"];
    backdropPath = json["backdrop_path"];
    popularity = json["popularity"];
    voteCount = json["vote_count"];
    video = json["video"];
    voteAverage = json["vote_average"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["poster_path"] = posterPath;
    _data["adult"] = adult;
    _data["overview"] = overview;
    _data["release_date"] = releaseDate;
    _data["original_title"] = originalTitle;
    if (genreIds != null) {
      _data["genre_ids"] = genreIds;
    }
    _data["id"] = id;
    _data["media_type"] = mediaType;
    _data["original_language"] = originalLanguage;
    _data["title"] = title;
    _data["backdrop_path"] = backdropPath;
    _data["popularity"] = popularity;
    _data["vote_count"] = voteCount;
    _data["video"] = video;
    _data["vote_average"] = voteAverage;
    return _data;
  }

  TheMoviePersonKnownFor copyWith({
    String? posterPath,
    bool? adult,
    String? overview,
    String? releaseDate,
    String? originalTitle,
    List<int>? genreIds,
    int? id,
    String? mediaType,
    String? originalLanguage,
    String? title,
    String? backdropPath,
    num? popularity,
    int? voteCount,
    bool? video,
    num? voteAverage,
  }) =>
      TheMoviePersonKnownFor(
        posterPath: posterPath ?? this.posterPath,
        adult: adult ?? this.adult,
        overview: overview ?? this.overview,
        releaseDate: releaseDate ?? this.releaseDate,
        originalTitle: originalTitle ?? this.originalTitle,
        genreIds: genreIds ?? this.genreIds,
        id: id ?? this.id,
        mediaType: mediaType ?? this.mediaType,
        originalLanguage: originalLanguage ?? this.originalLanguage,
        title: title ?? this.title,
        backdropPath: backdropPath ?? this.backdropPath,
        popularity: popularity ?? this.popularity,
        voteCount: voteCount ?? this.voteCount,
        video: video ?? this.video,
        voteAverage: voteAverage ?? this.voteAverage,
      );
}
